﻿Imports Microsoft.VisualBasic
Imports System.Web
Imports Google.GData.Calendar
Imports Google.GData.Client
Imports Google.GData

' ---------------------------------------------------------------------------
' Filename:		GoogleCalendar.vb
' By:			Steph@ne
' Created:		29-01-2011
' Updated:		
' Version:		1
' 
' ---------------------------------------------------------------------------

Sub Initialisation(parm as object)
	' ------- INSERTION DES DLL DANS SETTINGS.INI
	Dim parametre as string = ",Google.Gdata.Calendar;Google.Gdata.Calendar.dll,Google.Gdata.Client;Google.Gdata.Client.dll,Google.Gdata.Extentions;Google.Gdata.Extensions.dll,Google.GData.AccessControl;Google.GData.AccessControl.DLL,"
	Dim TrouveParametre as integer = InStr(hs.GetINISetting("Settings", "ScriptingReferences", "", "settings.ini"),parametre)
	if TrouveParametre=0 then
		hs.writelog("GoogleCalendar.vb","Paramètrage dans settings.ini manquant.")
		hs.SaveINISetting("settings","ScriptingReferences",hs.GetINISetting("Settings", "ScriptingReferences", "", "settings.ini") & "," & parametre,"settings.ini")
		hs.writelog("GoogleCalendar.vb","Paramètre dans settings.ini ajouté. Redémarrer Homeseer")
	Else
		hs.writelog("GoogleCalendar.vb","Paramètre dans settings.ini trouvé. Pas d'action.")
	End if
	
	' ------- CREATION DES DEVICES POUR LE STATUS ALLDAY
	Dim i as integer=1
	While not hs.GetINISetting("Calendrier" & i,"HcDc" , "", "GoogleCalendar.ini") = ""
		Dim ExistDev as long = hs.DeviceExistsRef(hs.GetINISetting("Calendrier" & i, "HcDc", "", "GoogleCalendarini"))
		If ExistDev=-1 then
			Dim dv as object
			dv = hs.NewDeviceEx(hs.GetINISetting("Calendrier" & i, "Nom", "", "GoogleCalendar.ini") & " (allday)")
			dv.dc=right(hs.GetINISetting("Calendrier" & i, "HcDc", "", "GoogleCalendar.ini"),len(hs.GetINISetting("Calendrier" & i, "HcDc", "", "GoogleCalendar.ini"))-1)
			dv.hc=left(hs.GetINISetting("Calendrier" & i, "HcDc", "", "GoogleCalendar.ini"),1)
			dv.location2=hs.GetINISetting("Parametres", "Location1", "", "GoogleCalendar.ini")
			dv.location=hs.GetINISetting("Parametres", "Location2", "", "GoogleCalendar.ini")
			dv.dev_type_string="Status GoogleCalendar"
			dv.misc=&h10
		else
			hs.writelog("GoogleCalendar.vb","Calendrier " & hs.GetINISetting("Device" & i, "HcDc", "", "GoogleCalendar.ini") & " existe déjà.")
		end if
		i = i + 1
		hs.SaveEventsDevices
	End while
	
	' ------- CREATION DE L'EVENEMENT ASSOCIE AU SCRIPT
	hs.writelog("GoogleCalendar.vb","Vérification de l'événement.")
	if hs.EventExists(hs.GetINISetting("Parametres", "NomGroupeEvent", "", "GoogleCalendar.ini")) then hs.DeleteEvent(hs.GetINISetting("Parametres", "NomGroupeEvent", "", "GoogleCalendar.ini"))
	Dim eve As Scheduler.Classes.EventClass._EventClass
	dim ref as long
	dim script as string
	hs.writelog("GoogleCalendar.vb","Création de l'événement " & hs.GetINISetting("Parametres", "NomGroupeEvent", "", "GoogleCalendar.ini") & " toutes les " & hs.GetINISetting("Parametres", "AutoEvent", "", "GoogleCalendar.ini") & " mn" )
	ref=hs.NewEventGetRef(hs.GetINISetting("Parametres", "NomGroupeEvent", "", "GoogleCalendar.ini"))
	eve=hs.GetEventByRef(ref)
	eve.ev_abs_time=6
	eve.rec_mins=hs.GetINISetting("Parametres", "AutoEvent", "", "GoogleCalendar.ini")
	eve.group=""
	hs.clearactions(ref)
	script="&hs.runex(""GoogleCalendar.vb"",""Main"","" "")"
	hs.addaction(ref,5,script)
	hs.EnableEvent(hs.GetINISetting("Parametres", "NomGroupeEvent", "", "GoogleCalendar.ini"))
	eve=nothing
End Sub


Sub Main(param as object)
	Dim calendriers() As String = hs.GetINISetting("Parametres", "Calendriers", "", "GoogleCalendar.ini").Split(",")
    Dim i As Integer
    For i = LBound(calendriers) To UBound(calendriers)
		
        TrouveEvent(calendriers(i))

    Next
    SynchroHsGoogle()
end sub

Sub TrouveEvent(ByVal calendrier As String)

        Dim StrModeLog As String = hs.GetINISetting("Parametres", "ModeLog", "", "GoogleCalendar.ini")
        Dim StrLogin As String = hs.GetINISetting("Parametres", "Login", "", "GoogleCalendar.ini")
        Dim StrPassword As String = hs.GetINISetting("Parametres", "Password", "", "GoogleCalendar.ini")
        Dim StrNom As String = hs.GetINISetting(calendrier, "Nom", "", "GoogleCalendar.ini")
        Dim StrDomotique As String = hs.GetINISetting(calendrier, "Domotique", "", "GoogleCalendar.ini")
        Dim StrHcDc As String = hs.GetINISetting(calendrier, "HcDc", "", "GoogleCalendar.ini")
        Dim StrUrl As String = hs.GetINISetting(calendrier, "Url", "", "GoogleCalendar.ini")
		
		hs.SetDeviceString(StrHcDc, hs.GetINISetting("Parametres", "StringNonEvenement", "", "GoogleCalendar.ini"))
		hs.SetDeviceLastChange(StrHcDc, Now)
		
        If StrLogin <> "" And StrPassword <> "" And StrNom <> "" And StrDomotique <> "" And StrHcDc <> "" And StrUrl <> "" Then

            Dim query As Google.GData.Calendar.EventQuery = New Google.GData.Calendar.EventQuery()
            Dim service As Google.GData.Calendar.CalendarService = New Google.GData.Calendar.CalendarService("test-application-name")
            service.setUserCredentials(StrLogin, StrPassword)
            query.Uri = New Uri(StrUrl)
            query.StartTime = Now
            query.EndTime = Now.AddDays(1)
            query.SortOrder = CalendarSortOrder.ascending
            Dim calFeed As Google.GData.Calendar.EventFeed = service.Query(query)
            Dim feedEntry As Google.GData.Calendar.EventEntry
            Dim DescEvent As String
			
            For Each feedEntry In calFeed.Entries

                ' ------- CAS JOURNEE ENTIERE
                
                If feedEntry.Times(0).AllDay = True And LCase(feedEntry.Locations(0).ValueString) = LCase(hs.GetINISetting("Parametres", "MotCle", "", "GoogleCalendar.ini")) And StrDomotique = 0 Then
                    hs.SetDeviceString(StrHcDc, feedEntry.Title.Text)
                    hs.SetDeviceLastChange(StrHcDc, Now)
                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", " [" & StrHcDc & "] " & StrNom & ": " & feedEntry.Title.Text & " (AllDay).")
                End If

                ' ------- CAS EVENEMENT HORAIRE NON DOMOTIQUE
                If feedEntry.Times(0).AllDay = False And LCase(feedEntry.Locations(0).ValueString) = LCase(hs.GetINISetting("Parametres", "MotCle", "", "GoogleCalendar.ini")) And StrDomotique = 0 And feedEntry.Times(0).StartTime > Now Then
                    'MsgBox("cas TTS")
                    Dim NomEvenement As String = StrNom & ": " & feedEntry.Title.Text
                    If hs.EventExists(NomEvenement) = False Then
                        Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventByRef(hs.NewEventGetRef(NomEvenement))
                        ev.group = hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")
                        ev.misc = &H10
                        ev.ev_abs_time = Classes.trigger_type_values.TYPE_TIME
                        ev.ev_time = DateAdd(DateInterval.Minute, CInt(-hs.GetINISetting("Parametres", "MinuteAvantSpeak", "", "GoogleCalendar.ini")), feedEntry.Times(0).StartTime)
                        ev.ev_date = feedEntry.Times(0).StartTime.Date
                        ev.UserNote = feedEntry.EventId.ToString
                        Dim script As String = "&hs.speak(""" & StrNom & ". " & feedEntry.Title.Text & " dans " & hs.GetINISetting("Parametres", "MinuteAvantSpeak", "", "GoogleCalendar.ini") & " minutes."")"
                        hs.AddAction(ev.evref, 5, script)
                        ev = Nothing
                        If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " inexistant. Création effectuée ...")
                    Else
                        If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " déjà existant. Vérification horaire...")
                        Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventEx(NomEvenement)
                        If ev.ev_time <> DateAdd(DateInterval.Minute, CInt(-hs.GetINISetting("Parametres", "MinuteAvantSpeak", "", "GoogleCalendar.ini")), feedEntry.Times(0).StartTime) Then
                            ev.ev_time = DateAdd(DateInterval.Minute, CInt(-hs.GetINISetting("Parametres", "MinuteAvantSpeak", "", "GoogleCalendar.ini")), feedEntry.Times(0).StartTime)
                            If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & "  horaire différent. Synchronisation effectuée.")
                        Else
                            If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " horaire identique à GoogleCalendar. Pas de Modif.")
                        End If
                        ev = Nothing
                    End If
                End If

                ' ------- CAS EVENEMENT HORAIRE DOMOTIQUE
                If feedEntry.Times(0).AllDay = False And feedEntry.Content.Content <> "" And feedEntry.Locations(0).ValueString <> "" And StrDomotique = 1 And feedEntry.Times(0).StartTime > Now Then
                    'MsgBox("cas Domotique")
                    Select Case LCase(feedEntry.Locations(0).ValueString)
                        Case LCase(hs.GetINISetting("Domotique", "MotCleOnOff", "", "GoogleCalendar.ini"))
                            MsgBox("cas ONOFF")
                            Dim NomEvenement As String = StrNom & ": " & feedEntry.Title.Text
                            If hs.EventExists(NomEvenement) = False Then
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventByRef(hs.NewEventGetRef(NomEvenement))
                                ev.group = hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")
                                ev.misc = &H10
                                ev.ev_abs_time = Classes.trigger_type_values.TYPE_TIME
                                ev.ev_time = feedEntry.Times(0).StartTime
                                ev.ev_date = feedEntry.Times(0).StartTime.Date
                                ev.UserNote = feedEntry.EventId.ToString
                                hs.AddAction(ev.evref, 1, hs.GetDeviceRef(feedEntry.Content.Content), "on")
                                hs.AddAction(ev.evref, 11, DateDiff(DateInterval.Minute, feedEntry.Times(0).StartTime, feedEntry.Times(0).EndTime))
                                hs.AddAction(ev.evref, 1, hs.GetDeviceRef(feedEntry.Content.Content), "off")
                                ev = Nothing
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " inexistant. Création effectuée ...")
                            Else
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " déjà existant. Vérification horaire...")
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventEx(NomEvenement)
                                If ev.ev_time <> feedEntry.Times(0).StartTime Then
                                    ev.ev_time = feedEntry.Times(0).StartTime
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & "  horaire différent. Synchronisation effectuée.")
                                Else
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " horaire identique à GoogleCalendar. Pas de Modif.")
                                End If
                                ev = Nothing
                            End If


                        Case LCase(hs.GetINISetting("Domotique", "MotCleOffOn", "", "GoogleCalendar.ini"))
                            'MsgBox("cas OFFON")
                            Dim NomEvenement As String = StrNom & ": " & feedEntry.Title.Text
                            If hs.EventExists(NomEvenement) = False Then
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventByRef(hs.NewEventGetRef(NomEvenement))
                                ev.group = hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")
                                ev.misc = &H10
                                ev.ev_abs_time = Classes.trigger_type_values.TYPE_TIME
                                ev.ev_time = feedEntry.Times(0).StartTime
                                ev.ev_date = feedEntry.Times(0).StartTime.Date
                                ev.UserNote = feedEntry.EventId.ToString
                                hs.AddAction(ev.evref, 1, hs.GetDeviceRef(feedEntry.Content.Content), "off")
                                hs.AddAction(ev.evref, 11, DateDiff(DateInterval.Minute, feedEntry.Times(0).StartTime, feedEntry.Times(0).EndTime))
                                hs.AddAction(ev.evref, 1, hs.GetDeviceRef(feedEntry.Content.Content), "on")
                                ev = Nothing
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " inexistant. Création effectuée ...")
                            Else
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " déjà existant. Vérification horaire...")
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventEx(NomEvenement)
                                If ev.ev_time <> feedEntry.Times(0).StartTime Then
                                    ev.ev_time = feedEntry.Times(0).StartTime
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & "  horaire différent. Synchronisation effectuée.")
                                Else
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " horaire identique à GoogleCalendar. Pas de Modif.")
                                End If
                                ev = Nothing
                            End If

						' ------- CAS EVENEMENT HORAIRE EVENT
                        Case LCase(hs.GetINISetting("Domotique", "MotCleEvent", "", "GoogleCalendar.ini"))
                            'MsgBox("cas EVENT")
                            Dim NomEvenement As String = StrNom & ": " & feedEntry.Title.Text
                            If hs.EventExists(NomEvenement) = False Then
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventByRef(hs.NewEventGetRef(NomEvenement))
                                ev.group = hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")
                                ev.misc = &H10
                                ev.ev_abs_time = Classes.trigger_type_values.TYPE_TIME
                                ev.ev_time = feedEntry.Times(0).StartTime
                                ev.ev_date = feedEntry.Times(0).StartTime.Date
                                ev.UserNote = feedEntry.EventId.ToString
                                hs.AddAction(ev.evref, 2, feedEntry.Content.Content)
                                ev = Nothing
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " inexistant. Création effectuée ...")
                            Else
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " déjà existant. Vérification horaire...")
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventEx(NomEvenement)
                                If ev.ev_time <> feedEntry.Times(0).StartTime Then
                                    ev.ev_time = feedEntry.Times(0).StartTime
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & "  horaire différent. Synchronisation effectuée.")
                                Else
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " horaire identique à GoogleCalendar. Pas de Modif.")
                                End If
                                ev = Nothing
                            End If
							
							' ------- CAS EVENEMENT HORAIRE SCRIPT
							Case LCase(hs.GetINISetting("Domotique", "MotCleScript", "", "GoogleCalendar.ini"))
                            'MsgBox("cas SCRIPT")
                            Dim NomEvenement As String = StrNom & ": " & feedEntry.Title.Text
                            If hs.EventExists(NomEvenement) = False Then
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventByRef(hs.NewEventGetRef(NomEvenement))
                                ev.group = hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")
                                ev.misc = &H10
                                ev.ev_abs_time = Classes.trigger_type_values.TYPE_TIME
                                ev.ev_time = feedEntry.Times(0).StartTime
                                ev.ev_date = feedEntry.Times(0).StartTime.Date
                                ev.UserNote = feedEntry.EventId.ToString
                                If feedEntry.Content.Content.ToString.StartsWith("&") Then
								msgbox("cas &")
								feedEntry.Content.Content = Replace(feedEntry.Content.Content.ToString, Chr(34), """")
								end if
                                hs.AddAction(ev.evref, 5, feedEntry.Content.Content)
                                ev = Nothing
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " inexistant. Création effectuée ...")
                            Else
                                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " déjà existant. Vérification horaire...")
                                Dim ev As Scheduler.Classes.EventClass._EventClass = hs.GetEventEx(NomEvenement)
                                If ev.ev_time <> feedEntry.Times(0).StartTime Then
                                    ev.ev_time = feedEntry.Times(0).StartTime
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & "  horaire différent. Synchronisation effectuée.")
                                Else
                                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & NomEvenement & " horaire identique à GoogleCalendar. Pas de Modif.")
                                End If
                                ev = Nothing
                            End If
							
							
                    End Select
                End If
            Next
			query=nothing
			service=nothing
        Else
            If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Paramètre manquant. Sub abandonnée pour " & calendrier)
        End If
		
End Sub

Sub SynchroHsGoogle()
        Dim StrModeLog As String = hs.GetINISetting("Parametres", "ModeLog", "", "GoogleCalendar.ini")
        Dim calendriers() As String = hs.GetINISetting("Parametres", "Calendriers", "", "GoogleCalendar.ini").Split(",")
        Dim i As Integer
        Dim en As Object = hs.GetEventEnumerator()
        Dim eve As Scheduler.Classes.EventClass._EventClass
        Do While Not en.finished
            Dim EventTrouve As Integer = 0
            eve = en.getnext
            If LCase(eve.group) = LCase(hs.GetINISetting("Parametres", "NomgroupeEvent", "", "GoogleCalendar.ini")) Then
                If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Synchro event " & eve.Name & " ...")
                For i = LBound(calendriers) To UBound(calendriers)

                    Dim StrLogin As String = hs.GetINISetting("Parametres", "Login", "", "GoogleCalendar.ini")
                    Dim StrPassword As String = hs.GetINISetting("Parametres", "Password", "", "GoogleCalendar.ini")
                    Dim StrUrl As String = hs.GetINISetting(calendriers(i), "Url", "", "GoogleCalendar.ini")
                    If StrLogin <> "" And StrPassword <> "" And StrUrl <> "" Then
                        Dim query As Google.GData.Calendar.EventQuery = New Google.GData.Calendar.EventQuery()
                        Dim service As Google.GData.Calendar.CalendarService = New Google.GData.Calendar.CalendarService("test-application-name")
                        service.setUserCredentials(StrLogin, StrPassword)
                        query.Uri = New Uri(StrUrl)
                        query.StartTime = Now
                        query.EndTime = Now.AddDays(2)
                        query.SortOrder = CalendarSortOrder.ascending

                        Dim calFeed As Google.GData.Calendar.EventFeed = service.Query(query)
                        Dim feedEntry As Google.GData.Calendar.EventEntry
                        For Each feedEntry In calFeed.Entries
                            If eve.UserNote = feedEntry.EventId.ToString Then EventTrouve = 1
                        Next
						query=nothing
						service=nothing
                    End If
                Next
                If EventTrouve = 0 Then
                    hs.DeleteEvent(eve.Name)
                    If StrModeLog = 1 Then hs.WriteLog("GoogleCalendar.vb", "Event " & eve.Name & " inexistant sur GoogleCalendar. Suppression.")
                End If
            End If


        Loop
        en = Nothing
        eve = Nothing

    End Sub
